/*****************************************************************************
 *
 * Atmel Corporation
 *
 * ̧		: AVRInSystemProg.cpp
 * ߲	: Dev-C++ 4.9.8.0 - http://bloodshed.net/dev/
 * 		: $Revision: 1163 $
 * t		: $Date: 2006N82 15:38:16 +0200 $
 * XV	: $Author: ohlia $
 *
 * xҰ	: avr@atmel.com
 *
 * ړI	: Win32
 *
 * pLq	: AVR911 - AVRJ݊
 *
 * 		: AVR910pLqŋLqAVR ISPɑ΂̪񋟂׽B
 *			  ̸׽AVRProgrammerh܂B
 *
 ****************************************************************************/

#include "AVRInSystemProg.hpp"

#include <sstream>
#include <iomanip>

#define MEM_PROGRESS_GRANULARITY 256 // For use with progress indicator.

/* ݽ׸ */
AVRInSystemProg::AVRInSystemProg( CommChannel * _comm ) :
	AVRProgrammer::AVRProgrammer( _comm )
{
	/* ̺ނȂ */
}

/* ޽׸ */
AVRInSystemProg::~AVRInSystemProg()
{
	/* ̺ނȂ */
}

bool AVRInSystemProg::enterProgrammingMode()
{
	/* AVRISP޲\޲IȂ΂Ȃ܂B */
	comm->sendByte( 'T' );
	comm->sendByte( 0x64 );					// ATmega163IA\łǂꂩ޲sB
	comm->flushTX();

	/* CRԂׂ */
	if( comm->getByte() != '\r' )
		throw new ErrorMsg( "Entering programming mode failed! "
				"Programmer did not return CR after 'T'-command." );

	/* 'P'߂𑗐M */
	comm->sendByte( 'P' );
	comm->flushTX();

	/* CRԂׂ */
	if( comm->getByte() != '\r' )
		throw new ErrorMsg( "Entering programming mode failed! "
				"Programmer did not return CR after 'P'-command." );

	return true;							// x閽߂
}

bool AVRInSystemProg::leaveProgrammingMode()
{
	/* 'L'߂𑗐M */
	comm->sendByte( 'L' );
	comm->flushTX();

	/* CRԂׂ */
	if( comm->getByte() != '\r' )
		throw new ErrorMsg( "Leaving programming mode failed! "
				"Programmer did not return CR after 'L'-command." );

	return true;							// x閽߂
}

bool AVRInSystemProg::chipErase()
{
	/* 'e'߂𑗐M */
	comm->sendByte( 'e' );
	comm->flushTX();

	if( comm->getByte() != '\r' )
		throw new ErrorMsg( "Chip erase failed! "
							"Programmer did not return CR after 'e'-command." );

	return true;							// x閽߂
}

bool AVRInSystemProg::readOSCCAL( long pos, long * value )
{
	/* AVRISP4޲Ė\߂gp */
	comm->sendByte( '.' );
	comm->sendByte( 0x38 );
	comm->sendByte( 0x00 );
	comm->sendByte( pos );
	comm->sendByte( 0x00 );					// 
	comm->flushTX();

	*value = comm->getByte();

	if( comm->getByte() != '\r' )			// ߂̕A
		throw new ErrorMsg( "OSCCAL value readout failed! "
							"Programmer did not return CR after '.'-command." );

	return true;							// x閽߂
}

bool AVRInSystemProg::readSignature( long * sig0, long * sig1, long * sig2 )
{
	/* 's'߂𑗐M */
	comm->sendByte( 's' );
	comm->flushTX();

	/* ۂ̎[擾 */
	*sig2 = comm->getByte();
	*sig1 = comm->getByte();
	*sig0 = comm->getByte();
}

bool AVRInSystemProg::checkSignature( long sig0, long sig1, long sig2 )
{
	long sig[3];

	/* [擾 */
	readSignature( sig, sig+1, sig+2 );

	/* [r */
	if( sig[0] != sig0 || sig[1] != sig1 || sig[2] != sig2 )
	{
		ostringstream msg;
		msg << "Signature does not match selected device! ";
		msg << "Actual signature: (" << hex
			<< "0x" << setw(2) << sig[0] << " "
			<< "0x" << setw(2) << sig[1] << " "
			<< "0x" << setw(2) << sig[2] << ") "
			<< "Signature from XML-file: (" << hex
			<< "0x" << setw(2) << sig0 << " "
			<< "0x" << setw(2) << sig1 << " "
			<< "0x" << setw(2) << sig2 << ").";

		throw new ErrorMsg( msg.str() );
	}

	return true;							// x閽߂
}

bool AVRInSystemProg::writeFlashByte( long address, long value )
{
	if( address >= 0x20000 )
		throw new ErrorMsg( "Flash addresses above 128k are currently not supported!" );

	setAddress( address >> 1 );				// ׯ͌ڽgp

	/* ڽ̏ꍇްړ */
	if( address & 0x01 )					// ڽ?
		value = (value << 8) | 0x00ff;		// ׯ1̏޲ĂɈړ
	else
		value |= 0xff00;					// ޲Ăɑ΂ďȂƂۏ

	/* ʂƏʂ޲Ă𑗏o */
	writeFlashLowByte( value & 0xff );
	writeFlashHighByte( value >> 8 );

	/* KvƂȂ߰ޏ݂𔭍s */
	if( pagesize != -1 )
	{
		setAddress( address >> 1 );			// ڽ͎܂B
		writeFlashPage();
	}

	return true;							// x閽߂
}

bool AVRInSystemProg::writeEEPROMByte( long address, long value )
{
	if( address >= 0x10000 )
		throw new ErrorMsg( "EEPROM addresses above 64k are currently not supported!" );

	setAddress( address );

	/* ް𑗐M */
	comm->sendByte( 'D' );
	comm->sendByte( value );
	comm->flushTX();

	/* CRԂׂ */
	if( comm->getByte() != '\r' )
		throw new ErrorMsg( "Writing byte to EEPROM failed! "
							"Programmer did not return CR after 'D'-command." );

	return true;							// x閽߂
}

bool AVRInSystemProg::writeFlash( HEXFile * data )
{
	long start, end;						// ް ڽ͈
	bool autoincrement;						// ް۰ނڽx邩?
	long address;

	/* ߰ޗeʂݒ肳Ă邱Ƃ𒲍 */
	if( pagesize == -1 )
		throw new ErrorMsg( "Programmer pagesize is not set!" );

	/* HEX̧ق͈͂擾 */
	start = data->getRangeStart();
	end = data->getRangeEnd();

	/* x */
	comm->sendByte( 'a' );
	comm->flushTX();

	if( comm->getByte() == 'Y' )
		autoincrement = true;
	else
		autoincrement = false;

	/* ڽݒ */
	setAddress( start >> 1 );				// ׯ͌ڽgp

	/* 1̊޲ď݂Kv? */
	address = start;
	if( address & 1 )
	{
		/* ޲Ă̂ݎgp */
		writeFlashLowByte( 0xff );			// ޲Ăɂ͏Ȃ
		writeFlashHighByte( data->getData( address ) );

		address++;

		/* ߰ޏ݂Kv? */
		if( pagesize != -1 )
		{
			if( !(address % pagesize) )		// x߰ދE𒴉?
			{
				setAddress( (address-1) >> 1 );	// ߰ޓ̱ڽɐݒ
				writeFlashPage();
				setAddress( address >> 1 );
			}
		}
	}

	/* ꏑ */
	do
	{
		/* Ăѱڽݒ肪Kv? */
		if( !autoincrement )
			setAddress( address >> 1 );

		/* ꏑ */
		writeFlashLowByte( data->getData( address ) );
		writeFlashHighByte( data->getData( address+1 ) );

		address += 2;

		if( (address % MEM_PROGRESS_GRANULARITY) == 0 )
			Util.progress( "#" );			// i\is

		/* ߰ޏ݂Kv? */
		if( pagesize != -1 )
		{
			if( (address % pagesize) == 0 )	// x߰ދE𒴉?
			{
				setAddress( (address-2) >> 1 );	// ߰ޓ̱ڽɐݒ
				writeFlashPage();
				setAddress( address >> 1 );
			}
		}
	} while( address < end );

	/* IO1̋޲ď݂Kv? */
	if( address == end )
	{
		/* ޲Ă̂ݎgp */
		writeFlashLowByte( data->getData( address ) );
		writeFlashHighByte( 0xff );			// ޲Ăł݂̏Ȃ
	}

	/* ߰ޏ݂Kv? */
	if( pagesize != -1 )
	{
		if( address == end ||				// 1̒ǉ޲ĂꂽA܂
			(end+1)%pagesize != 0 )			// Ōオ߰EłȂ
		{
			setAddress( (address-2) >> 1 );	// ߰ޓ̱ڽɐݒ
			writeFlashPage();
		}
	}

	Util.progress( "\r\n" );				// i\I
	return true;							// x閽߂
}

bool AVRInSystemProg::readFlash( HEXFile * data )
{
	long start, end;						// ް ڽ͈
	bool autoincrement;						// ް۰ނڽx?
	long address;

	if( pagesize == -1 )
		throw new ErrorMsg( "Programmer pagesize is not set!" );

	/* HEX̧ق͈͂擾 */
	start = data->getRangeStart();
	end = data->getRangeEnd();

	/* x */
	comm->sendByte( 'a' );
	comm->flushTX();

	if( comm->getByte() == 'Y' )
		autoincrement = true;
	else
		autoincrement = false;

	/* ڽݒ */
	setAddress( start >> 1 );				// ׯ͌ڽgp

	/* 1̊޲ēǂݍ݂Kv? */
	address = start;
	if( address & 1 )
	{
		/* ǂݍ݁A޲Ăgp */
		comm->sendByte( 'R' );
		comm->flushTX();

		data->setData( address, comm->getByte() );	// ޲
		comm->getByte();							// ޲ĕsgp

		address++;
	}

	/* 擾 */
	do
	{
		/* Ăѱڽݒ肪Kv? */
		if( !autoincrement )
			setAddress( address >> 1 );

		/* 擾 */
		comm->sendByte( 'R' );
		comm->flushTX();

		data->setData( address+1, comm->getByte() );	// ޲
		data->setData( address, comm->getByte() );		// ޲

		address += 2;

		if( (address % MEM_PROGRESS_GRANULARITY) == 0 )
			Util.progress( "#" );			// i\is

	} while( address < end );

	/* IO1̋޲ēǂݍ݂Kv? */
	if( address == end )
	{
		/* ǂݍ݁A޲Ăgp */
		comm->sendByte( 'R' );
		comm->flushTX();

		comm->getByte();								// ޲ĕsgp
		data->setData( address-1, comm->getByte() );	// ޲
	}

	Util.progress( "\r\n" );				// i\I
	return true;							// x閽߂
}

bool AVRInSystemProg::writeEEPROM( HEXFile * data )
{
	long start, end;						// ް ڽ͈
	bool autoincrement;						// ް۰ނڽx?
	long address;

	/* HEX̧ق͈͂擾 */
	start = data->getRangeStart();
	end = data->getRangeEnd();

	/* x */
	comm->sendByte( 'a' );
	comm->flushTX();

	if( comm->getByte() == 'Y' )
		autoincrement = true;
	else
		autoincrement = false;

	/* ڽݒ */
	setAddress( start );

	/* ް𑗐M */
	address = start;
	do
	{
		/* Ăѱڽݒ肪Kv? */
		if( !autoincrement )
			setAddress( address );

		/* ޲đM */
		comm->sendByte( 'D' );
		comm->sendByte( data->getData( address ) );
		comm->flushTX();

		if( comm->getByte() != '\r' )
			throw new ErrorMsg( "Writing byte to EEPROM failed! "
					"Programmer did not return CR after 'D'-command." );

		if( (address % MEM_PROGRESS_GRANULARITY) == 0 )
			Util.progress( "#" );			// i\is

		address++;
	} while( address <= end );

	Util.progress( "\r\n" );				// i\I
	return true;							// x閽߂
}

bool AVRInSystemProg::readEEPROM( HEXFile * data )
{
	long start, end;						// ް ڽ͈
	bool autoincrement;						// ް۰ނڽx?
	long address;

	/* HEX̧ق͈͂擾 */
	start = data->getRangeStart();
	end = data->getRangeEnd();

	/* x */
	comm->sendByte( 'a' );
	comm->flushTX();

	if( comm->getByte() == 'Y' )
		autoincrement = true;
	else
		autoincrement = false;

	/* ڽݒ */
	setAddress( start );

	/* ް𑗐M */
	address = start;
	do
	{
		/* Ăѱڽݒ肪Kv? */
		if( !autoincrement )
			setAddress( address );

		/* ޲Ă擾 */
		comm->sendByte( 'd' );
		comm->flushTX();

		data->setData( address, comm->getByte() );

		if( (address % MEM_PROGRESS_GRANULARITY) == 0 )
			Util.progress( "#" );			// i\is

		address++;
	} while( address <= end );

	Util.progress( "\r\n" );				// i\I
	return true;							// x閽߂
}

bool AVRInSystemProg::writeLockBits( long bits )
{
	/* AVRISP4޲Ė\߂gp */
	comm->sendByte( '.' );
	comm->sendByte( 0xac );
	comm->sendByte( 0xe0 );
	comm->sendByte( 0x00 );					// 
	comm->sendByte( bits );

	comm->flushTX();
	comm->getByte();						// SPIʐM̕Ԃ蕄𖳎

	if( comm->getByte() != '\r' )			// ߂̕Ԃ蕄
		throw new ErrorMsg( "Writing lock bits failed! "
							"Programmer did not return CR after '.'-command." );

	return true;							// x閽߂
}

bool AVRInSystemProg::readLockBits( long * bits )
{
	/* AVRISP4޲Ė\߂gp */
	comm->sendByte( '.' );
	comm->sendByte( 0x58 );
	comm->sendByte( 0x00 );
	comm->sendByte( 0x00 );					// 
	comm->sendByte( 0x00 );					// 
	comm->flushTX();

	*bits = comm->getByte();

	if( comm->getByte() != '\r' )			// ߂̕Ԃ蕄
		throw new ErrorMsg( "Lock byte readout failed! "
				"Programmer did not return CR after '.'-command." );

	return true;							// x閽߂
}

bool AVRInSystemProg::writeFuseBits( long bits )
{
	/* AVRISP4޲Ė\߂gp */
	comm->sendByte( '.' );
	comm->sendByte( 0xac );
	comm->sendByte( 0xa0 );
	comm->sendByte( 0x00 );					// 
	comm->sendByte( bits & 0xff );
	comm->flushTX();

	comm->getByte();						// SPIʐM̕Ԃ蕄𖳎

	if( comm->getByte() != '\r' )			// ߂̕Ԃ蕄
		throw new ErrorMsg( "Low fuse byte programming failed! "
							"Programmer did not return CR after '.'-command." );

	/* AVRISP4޲Ė\߂gp */
	comm->sendByte( '.' );
	comm->sendByte( 0xac );
	comm->sendByte( 0xa8 );
	comm->sendByte( 0x00 );					// 
	comm->sendByte( bits >> 8 );
	comm->flushTX();

	comm->getByte();						// SPIʐM̕Ԃ蕄𖳎

	if( comm->getByte() != '\r' )			// ߂̕Ԃ蕄
		throw new ErrorMsg( "High fuse byte programming failed! "
							"Programmer did not return CR after '.'-command." );

	return true;							// x閽߂
}

bool AVRInSystemProg::readFuseBits( long * bits )
{
	long low, high;

	/* AVRISP4޲Ė\߂gp */
	comm->sendByte( '.' );
	comm->sendByte( 0x50 );
	comm->sendByte( 0x00 );
	comm->sendByte( 0x00 );					// 
	comm->sendByte( 0x00 );					// 
	comm->flushTX();

	low = comm->getByte();

	if( comm->getByte() != '\r' )			// ߂̕Ԃ蕄
		throw new ErrorMsg( "Low fuse byte readout failed! "
							"Programmer did not return CR after '.'-command." );

	/* AVRISP4޲Ė\߂gp */
	comm->sendByte( '.' );
	comm->sendByte( 0x58 );
	comm->sendByte( 0x08 );
	comm->sendByte( 0x00 );					// 
	comm->sendByte( 0x00 );					// 
	comm->flushTX();

	high = comm->getByte();

	if( comm->getByte() != '\r' )			// ߂̕Ԃ蕄
		throw new ErrorMsg( "Low fuse byte readout failed! "
				"Programmer did not return CR adter '.'-command." );

	/* ʂƏʂɒu */
	*bits = (high << 8) | low;

	return true;							// x閽߂
}

bool AVRInSystemProg::writeExtendedFuseBits( long bits )
{
	/* AVRISP4޲Ė\߂gp */
	comm->sendByte( '.' );
	comm->sendByte( 0xac );
	comm->sendByte( 0xa4 );
	comm->sendByte( 0x00 );					// 
	comm->sendByte( bits );
	comm->flushTX();

	comm->getByte();						// SPIʐM̕Ԃ蕄𖳎

	if( comm->getByte() != '\r' )			// ߂̕Ԃ蕄
		throw new ErrorMsg( "Extended fuse byte programming failed! "
							"Programmer did not return CR after '.'-command." );

	return true;							// x閽߂
}

bool AVRInSystemProg::readExtendedFuseBits( long * bits )
{
	/* AVRISP4޲Ė\߂gp */
	comm->sendByte( '.' );
	comm->sendByte( 0x50 );
	comm->sendByte( 0x08 );
	comm->sendByte( 0x00 );					// 
	comm->sendByte( 0x00 );					// 
	comm->flushTX();

	*bits = comm->getByte();

	if( comm->getByte() != '\r' )			// ߂̕Ԃ蕄
		throw new ErrorMsg( "Extended fuse byte readout failed! "
							"Programmer did not return CR after '.'-command." );

	return true;							// x閽߂
}

bool AVRInSystemProg::programmerSoftwareVersion( long * major, long * minor )
{
	/* ĳŔԍ𓾂邽߂'V'߂𑗐M */
	comm->sendByte( 'V' );
	comm->flushTX();

	/* ް擾 */
	*major = comm->getByte();
	*minor = comm->getByte();

	return true;							// x閽߂
}

bool AVRInSystemProg::programmerHardwareVersion( long * major, long * minor )
{
	/* ʰ޳Ŕԍ𓾂邽߂'v'߂𑗐M */
	comm->sendByte( 'v' );
	comm->flushTX();

	/* ް擾 */
	*major = comm->getByte();
	*minor = comm->getByte();

	return true;							// x閽߂
}

void AVRInSystemProg::setAddress( long address )
{
	/* ݂̱ڽݒ */
	comm->sendByte( 'A' );
	comm->sendByte( address >> 8 );			// ڽ̏޲
	comm->sendByte( address & 0xff );		// ޲
	comm->flushTX();

	/* CRԂׂ */	
	if( comm->getByte() != '\r' )
		throw new ErrorMsg( "Setting address for programming operations failed! "
							"Programmer did not return CR after 'A'-command." );
}

void AVRInSystemProg::writeFlashLowByte( long value )
{
	comm->sendByte( 'c' );
	comm->sendByte( value );
	comm->flushTX();

	if( comm->getByte() != '\r' )
		throw new ErrorMsg( "Writing Flash low byte failed! "
							"Programmer did not return CR after 'c'-command." );
}

void AVRInSystemProg::writeFlashHighByte( long value )
{
	comm->sendByte( 'C' );
	comm->sendByte( value );
	comm->flushTX();

	if( comm->getByte() != '\r' )
		throw new ErrorMsg( "Writing Flash high byte failed! "
							"Programmer did not return CR after 'C'-command." );
}

void AVRInSystemProg::writeFlashPage()
{
	comm->sendByte( 'm' );
	comm->flushTX();

	if( comm->getByte() != '\r' )
		throw new ErrorMsg( "Writing Flash page failed! "
							"Programmer did not return CR after 'm'-command." );
}

/* ̧ق̍Ō */
